/* Copyright (C) 2001 Open Source Telecom Corporation.
 *  
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software 
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */ 

#include "server.h"

static xmlrpc_value *server_package(xmlrpc_env *env, xmlrpc_value *args,  void *user)
{
	char *auth;
	xmlrpc_parse_value(env, args, "(s)", &auth);
	if(env->fault_occurred)
		return NULL;

	if(apennine_auth(auth))
		return NULL;

	return xmlrpc_build_value(env, "(s)", PACKAGE);
}

static xmlrpc_value *server_version(xmlrpc_env *env, xmlrpc_value *args, void  *user)
{
	char *auth;

	xmlrpc_parse_value(env, args, "(s)", &auth);
	if(env->fault_occurred)
		return NULL;

	if(apennine_auth(auth))
		return NULL;

	return xmlrpc_build_value(env, "(s)", VERSION);
}

static int server_init(void)
{
	return 0;
}

static void server_down(void)
{};

static apennine_method_t server_methods[] = {
	{"package", &server_package},	
	{"version", &server_version}};	

apennine_dso_t server_dso = {
	NULL, NULL,
	"server",
	&server_init,
	&server_down,
	2,
	server_methods
};

